#include "gbc.inc"

DisplayBungLogo::
		di

		ld a,$c3
		ldh ($83),a
		ld hl,LogoVBlank
		ld a,l
		ldh ($84),a
		ld a,h
		ldh ($85),a

		ld a,1
        ld [fadeType],a

        ld a,1
        ld [fadeInProgress],a

waitForVBlank:
        ldh a,[LY]
        cp 145
        jr nz,waitForVBlank

        sub a   ; ld a,0
        ldh [LCDC],a

		ldh (SCX),a
		ldh (SCY),a

        sub a   ; ld a,0
        ldh [VBK],a
        ld hl,$8000
        ld de,LogoTiles
        ld bc,158*16
copyLoop:
        ld a,[de]
        inc de
        ld [hl+],a
        dec bc
        ld a,b
        or c
        jr nz,copyLoop

        ld hl,$9800
        ld de,LogoMapPLN0
        ld c,18
mapYLoop:
        ld b,20
mapXLoop:
        ld a,[de]
        inc de
        ld [hl+],a
        dec b
        ld a,b
        or a
        jr nz,mapXLoop
        push bc
        ld bc,12
        add hl,bc
        pop bc
        dec c
        ld a,c
        or a
        jr nz,mapYLoop

        ld a,1
        ldh [VBK],a
        ld hl,$9800
        ld c,18
mapYLoop2:
        ld b,20
mapXLoop2:
        xor a
        ld [hl+],a
        dec b
        ld a,b
        or a
        jr nz,mapXLoop2
        push bc
        ld bc,12
        add hl,bc
        pop bc
        dec c
        ld a,c
        or a
        jr nz,mapYLoop2

        ld a,$80
        ldh [BCPS],a
        ld a,[fadeType]
        or a
        jr z,black1
        ld a,$ff
        jr writePal1
black1:
        sub a   ; ld a,0
writePal1:
        ldh [BCPD],a
        ldh [BCPD],a
        ldh [BCPD],a
        ldh [BCPD],a
        ldh [BCPD],a
        ldh [BCPD],a
        ldh [BCPD],a
        ldh [BCPD],a
        ldh [BCPD],a
        ldh [BCPD],a
        ldh [BCPD],a
        ldh [BCPD],a
        ldh [BCPD],a
        ldh [BCPD],a
        ldh [BCPD],a
        ldh [BCPD],a

        ld a,1
        ldh [$ff],a

        ld hl,FadeA0
        call InitFade
        ld hl,FadeA1
        call InitFade
        ld hl,FadeA2
        call InitFade
        ld hl,FadeA3
        call InitFade
        ld hl,FadeB0
        call InitFade
        ld hl,FadeB1
        call InitFade
        ld hl,FadeB2
        call InitFade
        ld hl,FadeB3
        call InitFade

        sub a   ; ld a,0
        ld [fadeCount],a
        ld a,1
        ld [fadeEnable],a

        ld a,$91
        ldh [LCDC],a

        ei

fadeInLoop:
        halt
        nop
        ld a,[fadeCount]
        cp 32
        jr c,fadeInLoop

        di

        ld a,$80
        ldh [BCPS],a
        ld bc,LogoTilesCGBPal0c0
        ld a,c
        ldh [BCPD],a
        ld a,b
        ldh [BCPD],a
        ld bc,LogoTilesCGBPal0c1
        ld a,c
        ldh [BCPD],a
        ld a,b
        ldh [BCPD],a
        ld bc,LogoTilesCGBPal0c2
        ld a,c
        ldh [BCPD],a
        ld a,b
        ldh [BCPD],a
        ld bc,LogoTilesCGBPal0c3
        ld a,c
        ldh [BCPD],a
        ld a,b
        ldh [BCPD],a

        sub a   ; ld a,0
        ld [fadeEnable],a
        sub a   ; ld a,0
        ld [fadeCount],a

        ei

waitloop:
		halt
        nop
        ld a,[fadeCount]
        cp 200
        jr c,waitloop

        sub a   ; ld a,0
        ld [fadeCount],a
        ld a,2
        ld [fadeEnable],a

        ei

fadeOutLoop:
        halt
        nop
        ld a,[fadeCount]
        cp 32
        jr c,fadeOutLoop

        di

        ld a,$80
        ldh [BCPS],a
        ld a,[fadeType]
        or a
        jr z,black3
        ld a,$ff
        jr writePal3
black3:
        sub a   ; ld a,0
writePal3:
        ldh [BCPD],a
        ldh [BCPD],a
        ldh [BCPD],a
        ldh [BCPD],a
        ldh [BCPD],a
        ldh [BCPD],a
        ldh [BCPD],a
        ldh [BCPD],a
        ldh [BCPD],a
        ldh [BCPD],a
        ldh [BCPD],a
        ldh [BCPD],a
        ldh [BCPD],a
        ldh [BCPD],a
        ldh [BCPD],a
        ldh [BCPD],a

dispLogoEnd:
        sub a   ; ld a,0
        ld [fadeEnable],a

        sub a   ; ld a,0
        ld [fadeInProgress],a

		ld a,$d9 ; reti
		ldh ($83),a

        ret

InitFade:
        sub a   ; ld a,0
        ld [hl+],a
        ld [hl+],a
        ld [hl+],a
        ld a,31
        ld [hl+],a
        ld [hl+],a
        ld [hl+],a
        ret

Fade:
        ld b,a
        ld a,[fadeType]
        or a
        jr z,FadeNormal
        ld a,[hl]
        add a,31
        sub a,b
        cp 32
        jr c,FadeEnd
        sub 32
        inc hl
        inc hl
        inc hl
        dec [hl]
        dec hl
        dec hl
        dec hl
        jr FadeEnd
FadeNormal:
        ld a,[hl]
        add a,b
        cp 32
        jr c,FadeEnd
        sub 32
        inc hl
        inc hl
        inc hl
        inc [hl]
        dec hl
        dec hl
        dec hl
FadeEnd:
        ld [hl+],a
        ret

FadeOut:
        ld b,a
        ld a,[fadeType]
        or a
        jr z,FadeOutNormal
        ld a,[hl]
        add a,b
        sub a,31
        jr nc,FadeOutEnd
        add a,32
        inc hl
        inc hl
        inc hl
        inc [hl]
        dec hl
        dec hl
        dec hl
        jr FadeOutEnd
FadeOutNormal:
        ld a,[hl]
        sub a,b
        jr nc,FadeOutEnd
        add a,32
        inc hl
        inc hl
        inc hl
        dec [hl]
        dec hl
        dec hl
        dec hl
FadeOutEnd:
        ld [hl+],a
        ret

FadeSetPal:
        inc hl
        inc hl
        ld a,[hl-]
        sla a
        sla a
        ld b,a
        ld a,[hl-]
        ld c,a
        srl a
        srl a
        srl a
        or b
        ld d,a
        ld a,c
        rrca
        rrca
        rrca
        and $e0
        ld b,a
        ld a,[hl-]
        or b
        ldh [BCPD],a
        ld a,d
        ldh [BCPD],a
        ret

LogoVBlank:
        ld a,[fadeEnable]
        or a
        jp z,vblankEnd
        cp 2
        jp z,vblankFadeOut
        ld a,$80
        ldh [BCPS],a
        ld hl,FadeA0
        ld a,31
        call Fade
        ld a,31
        call Fade
        ld a,31
        call Fade
        call FadeSetPal
        ld hl,FadeA1
        ld a,31
        call Fade
        ld a,21
        call Fade
        ld a,21
        call Fade
        call FadeSetPal
        ld hl,FadeA2
        ld a,31
        call Fade
        ld a,10
        call Fade
        ld a,10
        call Fade
        call FadeSetPal
        ld hl,FadeA3
        ld a,31
        call Fade
        ld a,0
        call Fade
        ld a,0
        call Fade
        call FadeSetPal
        jp vblankEnd
vblankFadeOut:
        ld a,$80
        ldh [BCPS],a
        ld hl,FadeA0
        ld a,31
        call FadeOut
		ld a,31
        call FadeOut
        ld a,31
        call FadeOut
        call FadeSetPal
        ld hl,FadeA1
        ld a,31
        call FadeOut
        ld a,21
        call FadeOut
        ld a,21
        call FadeOut
        call FadeSetPal
        ld hl,FadeA2
        ld a,31
        call FadeOut
        ld a,10
        call FadeOut
        ld a,10
        call FadeOut
        call FadeSetPal
        ld hl,FadeA3
        ld a,31
        call FadeOut
        ld a,0
        call FadeOut
        ld a,0
        call FadeOut
        call FadeSetPal
vblankEnd:
        ld hl,fadeCount
        inc [hl]
        reti

DisplayBungLogoDMG::
 ld a,$d9 ; reti
 ldh ($83),a
 ei
 ld a,%00000001
 ldh (IE),a
 ld a,%11100100
 ldh (BGP),a
@vbl:
 ldh a,(LY)
 cp 145
 jr nz,@vbl
 sub a
 ldh (LCDC),a
 ldh (SCX),a
 ldh (SCY),a
 ld hl,LogoTiles
 ld de,_OBPA
 ld bc,16*158
 call _ldir
 ld hl,LogoMap
 ld de,_BG1
 ld a,18
@copy:
 push af
 ld bc,20
 call _ldir
 push hl
 ld h,d
 ld l,e
 ld de,12
 add hl,de
 ld d,h
 ld e,l
 pop hl
 pop af
 dec a
 jr nz,@copy
 ld a,%10010001
 ldh (LCDC),a
 ld a,180
@wait:
 halt
 dec a
 jr nz,@wait 
 ret

_ldir:
 ldi a,(hl)
 ld (de),a
 inc de
 dec bc
 ld a,b
 or c
 jr nz,_ldir
 ret

; --
; -- Variables
; --

Temp = _BANK0

fadeEnable 		= Temp		; [1]
fadeCount 		= Temp + 1	; [1]
fadeInProgress 	= Temp + 2 	; [1]
fadeType		= Temp + 3	; [1]

FadeA0			= Temp + 4	; [6]
FadeA1			= Temp + 10	; [6]
FadeA2			= Temp + 16 ; [6]
FadeA3			= Temp + 22 ; [6]
FadeB0			= Temp + 28 ; [6]
FadeB1			= Temp + 34 ; [6]
FadeB2			= Temp + 40 ; [6]
FadeB3			= Temp + 46 ; [6]
							; [12]

LogoMapWidth  = 20
LogoMapHeight = 18
LogoMapBank   = 0

; Bank of tiles.
LogoTilesBank = 0

; Gameboy Color palette 0
LogoTilesCGBPal0c0 = (1024*31)+(32*31)+31
LogoTilesCGBPal0c1 = (1024*21)+(32*21)+31
LogoTilesCGBPal0c2 = (1024*10)+(32*10)+31
LogoTilesCGBPal0c3 = 31

LogoMap:
LogoMapPLN0:
.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$01,$02,$03,$04
.db $05,$06,$07,$08,$09,$0A,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$0B,$0C,$0D,$0E,$0F
.db $10,$11,$12,$13,$14,$15,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$16,$17,$18,$19,$1A
.db $1B,$1C,$1D,$1E,$1F,$20,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$21,$22,$23,$24,$25
.db $26,$27,$28,$29,$2A,$2B,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$2C,$2D,$2E,$2F,$30
.db $31,$32,$33,$34,$35,$36,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$37,$38,$39,$3A,$3B
.db $3C,$3D,$3E,$3F,$40,$41,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$42,$43,$44,$45,$46
.db $47,$48,$49,$4A,$4B,$4C,$00,$00,$00,$00
.db $5F,$00,$00,$00,$00,$4D,$4E,$4F,$50,$51
.db $52,$53,$54,$55,$56,$57,$00,$00,$00,$00
.db $6F,$00,$00,$00,$00,$00,$59,$5A,$5B,$5C
.db $5D,$5E,$5F,$00,$00,$00,$00,$00,$00,$00
.db $7F,$00,$00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
.db $8F,$00,$00,$60,$61,$62,$63,$64,$65,$66
.db $67,$68,$69,$6A,$6B,$6C,$6D,$00,$00,$00
.db $9F,$00,$00,$70,$71,$72,$73,$74,$75,$76
.db $77,$78,$79,$7A,$7B,$7C,$7D,$00,$00,$00
.db $AF,$B0,$B1,$80,$81,$82,$83,$84,$85,$86
.db $87,$88,$89,$8A,$8B,$8C,$8D,$00,$00,$00
.db $BF,$C0,$C1,$90,$91,$92,$93,$94,$95,$96
.db $97,$98,$99,$9A,$9B,$9C,$9D,$00,$00,$00
.db $CF,$D0,$D1,$D2,$D3,$D4,$D5,$D6,$D7,$D8
.db $D9,$DA,$DB,$DC,$DD,$DE,$00,$00,$00,$00
.db $DF,$E0,$E1,$E2,$E3,$E4,$E5,$E6,$E7,$E8
.db $E9,$EA,$EB,$EC,$ED,$EE,$00,$00,$00,$00

; Start of tile array.
LogoTiles:
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $03,$03,$0F,$0F,$3E,$3E,$78,$78
.db $00,$00,$00,$00,$07,$07,$7F,$7F
.db $FC,$FC,$80,$80,$1F,$1F,$FF,$FF
.db $00,$00,$00,$00,$FE,$FE,$FF,$FF
.db $03,$03,$60,$60,$FF,$FF,$FF,$FF
.db $00,$00,$00,$00,$00,$00,$F0,$F0
.db $FC,$FC,$1F,$1F,$C3,$C3,$F8,$F8
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$C0,$C0,$F0,$F0
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $01,$01,$03,$03,$07,$07,$0E,$0E
.db $1C,$1C,$39,$39,$73,$73,$E7,$E7
.db $E3,$E3,$8F,$8F,$3F,$3F,$7F,$7F
.db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
.db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
.db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
.db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
.db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
.db $FE,$FE,$FF,$FF,$FF,$FF,$FF,$FF
.db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
.db $78,$78,$9C,$9C,$CF,$CF,$F3,$F3
.db $F9,$F9,$FC,$FC,$FE,$FE,$FF,$FF
.db $00,$00,$00,$00,$00,$00,$80,$80
.db $80,$80,$C0,$C0,$60,$60,$70,$70
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$01,$01,$03,$03,$03,$03
.db $07,$07,$07,$07,$0F,$0F,$1E,$1E
.db $CF,$CF,$9F,$9F,$BF,$BF,$3F,$3F
.db $7F,$7F,$FF,$FF,$FF,$FF,$00,$00
.db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
.db $FF,$FF,$FF,$FF,$FF,$FF,$00,$00
.db $FF,$FF,$FF,$FF,$F8,$F8,$E0,$E0
.db $80,$80,$FF,$FF,$FF,$FF,$00,$00
.db $FF,$FF,$FF,$FF,$01,$01,$00,$00
.db $00,$00,$FF,$FF,$FF,$FF,$00,$00
.db $FF,$FF,$FF,$FF,$FF,$FF,$3F,$3F
.db $1F,$1F,$FF,$FF,$FF,$FF,$00,$00
.db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
.db $FF,$FF,$FF,$FF,$FF,$FF,$00,$00
.db $B8,$B8,$98,$98,$CC,$CC,$EE,$EE
.db $E6,$E6,$FF,$FF,$FF,$FF,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$FF,$FF,$FF,$FF,$01,$01
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$80,$80,$C0,$C0
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$01,$01,$01,$01
.db $38,$38,$70,$70,$61,$61,$63,$63
.db $C3,$C3,$C3,$C3,$C3,$C3,$83,$83
.db $00,$00,$00,$00,$FE,$FE,$FF,$FF
.db $FF,$FF,$C3,$C3,$C3,$C3,$83,$83
.db $00,$00,$00,$00,$03,$03,$83,$83
.db $C7,$C7,$C7,$C7,$C7,$C7,$C7,$C7
.db $00,$00,$00,$00,$81,$81,$83,$83
.db $83,$83,$83,$83,$83,$83,$03,$03
.db $00,$00,$00,$00,$C7,$C7,$C7,$C7
.db $CF,$CF,$CF,$CF,$8F,$8F,$8F,$8F
.db $00,$00,$00,$00,$03,$03,$83,$83
.db $87,$87,$C7,$C7,$C7,$C7,$C7,$C7
.db $00,$00,$00,$00,$81,$81,$87,$87
.db $8F,$8F,$8F,$8F,$1E,$1E,$3C,$3C
.db $00,$00,$00,$00,$F8,$F8,$FE,$FE
.db $FF,$FF,$0F,$0F,$07,$07,$00,$00
.db $00,$00,$00,$00,$01,$01,$01,$01
.db $03,$03,$03,$03,$83,$83,$06,$06
.db $C0,$C0,$C0,$C0,$C0,$C0,$80,$80
.db $80,$80,$00,$00,$00,$00,$00,$00
.db $03,$03,$03,$03,$03,$03,$06,$06
.db $06,$06,$0E,$0E,$0C,$0C,$0C,$0C
.db $87,$87,$07,$07,$07,$07,$07,$07
.db $07,$07,$0F,$0F,$0F,$0F,$0F,$0F
.db $FF,$FF,$FF,$FF,$FF,$FF,$87,$87
.db $03,$03,$03,$03,$07,$07,$FF,$FF
.db $87,$87,$0F,$0F,$8F,$8F,$CF,$CF
.db $CE,$CE,$CE,$CE,$8F,$8F,$8F,$8F
.db $07,$07,$07,$07,$07,$07,$07,$07
.db $0F,$0F,$0F,$0F,$1E,$1E,$FE,$FE
.db $8F,$8F,$9E,$9E,$9E,$9E,$1C,$1C
.db $1C,$1C,$1C,$1C,$3C,$3C,$3C,$3C
.db $E7,$E7,$EF,$EF,$FF,$FF,$FE,$FE
.db $7E,$7E,$7E,$7E,$3E,$3E,$3E,$3E
.db $3C,$3C,$38,$38,$38,$38,$38,$38
.db $38,$38,$3C,$3C,$3E,$3E,$1F,$1F
.db $00,$00,$7F,$7F,$7F,$7F,$7F,$7F
.db $0F,$0F,$0E,$0E,$3E,$3E,$FE,$FE
.db $06,$06,$0E,$0E,$0C,$0C,$0C,$0C
.db $18,$18,$18,$18,$38,$38,$30,$30
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $18,$18,$18,$18,$18,$18,$18,$18
.db $1F,$1F,$1F,$1F,$07,$07,$00,$00
.db $0F,$0F,$0F,$0F,$00,$00,$00,$00
.db $FF,$FF,$FF,$FF,$FF,$FF,$07,$07
.db $FF,$FF,$F8,$F8,$00,$00,$00,$00
.db $FF,$FF,$FF,$FF,$FF,$FF,$7F,$7F
.db $07,$07,$01,$01,$00,$00,$00,$00
.db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
.db $FC,$FC,$F0,$F0,$00,$00,$00,$00
.db $FF,$FF,$FF,$FF,$FF,$FF,$80,$80
.db $38,$38,$38,$38,$00,$00,$00,$00
.db $FF,$FF,$FF,$FF,$FF,$FF,$00,$00
.db $3C,$3C,$1C,$1C,$00,$00,$00,$00
.db $FF,$FF,$FF,$FF,$FF,$FF,$1F,$1F
.db $0F,$0F,$03,$03,$00,$00,$00,$00
.db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
.db $FC,$FC,$E0,$E0,$00,$00,$01,$01
.db $FF,$FF,$FF,$FF,$FE,$FE,$EE,$EE
.db $70,$70,$60,$60,$E0,$E0,$C0,$C0
.db $80,$80,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $03,$03,$03,$03,$01,$01,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $3F,$3F,$BF,$BF,$DF,$DF,$CF,$CF
.db $E7,$E7,$73,$73,$39,$39,$1C,$1C
.db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
.db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
.db $E0,$E0,$FC,$FC,$FF,$FF,$FF,$FF
.db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
.db $00,$00,$01,$01,$FF,$FF,$FF,$FF
.db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
.db $7F,$7F,$FF,$FF,$FF,$FF,$FF,$FF
.db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
.db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
.db $FE,$FE,$FE,$FE,$FC,$FC,$F9,$F9
.db $EC,$EC,$DC,$DC,$98,$98,$38,$38
.db $70,$70,$60,$60,$C0,$C0,$80,$80
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $0E,$0E,$07,$07,$03,$03,$01,$01
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $7F,$7F,$3F,$3F,$CF,$CF,$E3,$E3
.db $78,$78,$3E,$3E,$0F,$0F,$01,$01
.db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
.db $FF,$FF,$1F,$1F,$C0,$C0,$FF,$FF
.db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
.db $FF,$FF,$FF,$FF,$00,$00,$8F,$8F
.db $FF,$FF,$FF,$FF,$FF,$FF,$FC,$FC
.db $F1,$F1,$87,$87,$3F,$3F,$FC,$FC
.db $E3,$E3,$CE,$CE,$9C,$9C,$78,$78
.db $F0,$F0,$C0,$C0,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $7F,$7F,$03,$03,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $FF,$FF,$FC,$FC,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $E0,$E0,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$03,$03
.db $1F,$1F,$03,$03,$03,$03,$06,$06
.db $00,$00,$00,$00,$00,$00,$81,$81
.db $03,$03,$06,$06,$06,$06,$0C,$0C
.db $00,$00,$00,$00,$00,$00,$F0,$F0
.db $30,$30,$31,$31,$31,$31,$33,$33
.db $00,$00,$00,$00,$00,$00,$7C,$7C
.db $CC,$CC,$8C,$8C,$8C,$8C,$0C,$0C
.db $00,$00,$00,$00,$00,$00,$1F,$1F
.db $33,$33,$63,$63,$63,$63,$C3,$C3
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $01,$01,$07,$07,$0C,$0C,$18,$18
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $F8,$F8,$18,$18,$00,$00,$01,$01
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$F8,$F8,$9C,$9C
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $01,$01,$01,$01,$3F,$3F,$67,$67
.db $00,$00,$00,$00,$C3,$C3,$C3,$C3
.db $80,$80,$80,$80,$9F,$9F,$06,$06
.db $00,$00,$00,$00,$80,$80,$80,$80
.db $00,$00,$00,$00,$07,$07,$0F,$0F
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$E0,$E0,$61,$61
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$FE,$FE,$9C,$9C
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $06,$06,$06,$06,$0C,$0C,$0C,$0C
.db $0C,$0C,$FF,$FF,$00,$00,$00,$00
.db $0E,$0E,$07,$07,$00,$00,$00,$00
.db $01,$01,$1F,$1F,$00,$00,$00,$00
.db $73,$73,$E1,$E1,$60,$60,$C0,$C0
.db $80,$80,$07,$07,$00,$00,$00,$00
.db $9C,$9C,$F8,$F8,$18,$18,$30,$30
.db $60,$60,$C1,$C1,$00,$00,$00,$00
.db $E7,$E7,$7E,$7E,$06,$06,$0C,$0C
.db $18,$18,$F0,$F0,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $18,$18,$18,$18,$30,$30,$38,$38
.db $1C,$1C,$0F,$0F,$00,$00,$00,$00
.db $03,$03,$03,$03,$06,$06,$06,$06
.db $66,$66,$C3,$C3,$00,$00,$00,$00
.db $0C,$0C,$0C,$0C,$19,$19,$19,$19
.db $31,$31,$E0,$E0,$00,$00,$00,$00
.db $C3,$C3,$C3,$C3,$86,$86,$86,$86
.db $9E,$9E,$FC,$FC,$00,$00,$00,$00
.db $06,$06,$06,$06,$0C,$0C,$0C,$0C
.db $0C,$0C,$18,$18,$00,$00,$00,$00
.db $0C,$0C,$0C,$0C,$18,$18,$18,$18
.db $18,$18,$31,$31,$00,$00,$00,$00
.db $63,$63,$63,$63,$C6,$C6,$C6,$C6
.db $C6,$C6,$83,$83,$00,$00,$00,$00
.db $0C,$0C,$0C,$0C,$18,$18,$18,$18
.db $78,$78,$F0,$F0,$30,$30,$60,$60
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$07,$07
.db $1C,$1C,$30,$30,$60,$60,$60,$60
.db $00,$00,$00,$00,$00,$00,$E0,$E0
.db $60,$60,$03,$03,$06,$06,$0C,$0C
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$E1,$E1,$73,$73,$33,$33
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$FC,$FC,$FC,$FC,$6C,$6C
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$7E,$7E,$F3,$F3,$C3,$C3
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$0F,$0F,$19,$19,$31,$31
.db $00,$00,$00,$00,$00,$00,$01,$01
.db $01,$01,$87,$87,$83,$83,$83,$83
.db $00,$00,$00,$00,$00,$00,$80,$80
.db $80,$80,$F9,$F9,$00,$00,$00,$00
.db $00,$00,$38,$38,$38,$38,$00,$00
.db $00,$00,$F0,$F0,$60,$60,$60,$60
.db $00,$00,$00,$00,$00,$00,$18,$18
.db $18,$18,$7F,$7F,$30,$30,$30,$30
.db $00,$00,$03,$03,$03,$03,$00,$00
.db $00,$00,$9F,$9F,$06,$06,$06,$06
.db $00,$00,$80,$80,$80,$80,$00,$00
.db $00,$00,$03,$03,$06,$06,$0C,$0C
.db $0F,$0F,$00,$00,$00,$00,$00,$00
.db $00,$00,$E1,$E1,$73,$73,$33,$33
.db $C0,$C0,$00,$00,$00,$00,$00,$00
.db $00,$00,$F8,$F8,$D8,$D8,$18,$18
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $60,$60,$C0,$C0,$E0,$E0,$71,$71
.db $3F,$3F,$00,$00,$00,$00,$00,$00
.db $0C,$0C,$18,$18,$18,$18,$98,$98
.db $0F,$0F,$00,$00,$00,$00,$00,$00
.db $33,$33,$66,$66,$66,$66,$C6,$C6
.db $8D,$8D,$00,$00,$00,$00,$00,$00
.db $6C,$6C,$D9,$D9,$D9,$D9,$D9,$D9
.db $B3,$B3,$03,$03,$06,$06,$06,$06
.db $C3,$C3,$86,$86,$86,$86,$8C,$8C
.db $F8,$F8,$00,$00,$00,$00,$00,$00
.db $3F,$3F,$60,$60,$60,$60,$73,$73
.db $3E,$3E,$00,$00,$00,$00,$00,$00
.db $83,$83,$06,$06,$06,$06,$06,$06
.db $07,$07,$00,$00,$00,$00,$00,$00
.db $00,$00,$00,$00,$00,$00,$00,$00
.db $C1,$C1,$00,$00,$00,$00,$00,$00
.db $60,$60,$C0,$C0,$C0,$C0,$C0,$C0
.db $80,$80,$00,$00,$00,$00,$00,$00
.db $30,$30,$60,$60,$60,$60,$60,$60
.db $7C,$7C,$00,$00,$00,$00,$00,$00
.db $06,$06,$0C,$0C,$0C,$0C,$0C,$0C
.db $18,$18,$00,$00,$00,$00,$00,$00
.db $0C,$0C,$18,$18,$18,$18,$18,$18
.db $0F,$0F,$00,$00,$00,$00,$00,$00
.db $33,$33,$66,$66,$66,$66,$C6,$C6
.db $8C,$8C,$00,$00,$00,$00,$00,$00
.db $18,$18,$30,$30,$30,$30,$30,$30
.db $60,$60,$00,$00,$00,$00,$00,$00
